<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.act.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"file.lib.php", "image.lib.php", "downloads"
	);

	require_once GEKKO_ROOT."lib/auth.inc.php";

	varImport("action", "id", "return");

	if (is_admin()) {

		switch ($action) {
			case "delete_item":
				execWithEach($id, "downloads::deleteItem");
			break;
			case "delete":
				execWithEach($id, "downloads::deleteCategory");
			break;
			case "enable":
				downloads::setItemStatus($id, "1");
			break;
			case "disable":
				downloads::setItemStatus($id, "0");
			break;
			case "edit":

				varImport("id", "status", "categorylink", "title", "description",
				"auth_access", "filesize");

				varRequire("id", "title");

				// a thumbnail is required for a category to exists
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					$thumb = file_get("local_file", "remote_file", "temp");
					if ($thumb) {
						$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
						$icon = $thumb["url"];
					} else {
						abort("Couldn't upload thumbnail!");
					}
					// deleting old thumbnail
					$db->query("SELECT thumbnail FROM ".db_table("download")." WHERE id = '{$id}'", __FILE__, __LINE__);
					$row = $db->fetch_row();
					@unlink(GEKKO_ROOT.$row["thumbnail"]);
				} else {
					$thumb = false;
				}

				$db->query("UPDATE ".db_table("download")." SET
					title = '{$title}',
					description = '{$description}',
					categorylink = '{$categorylink}',
					status = '{$status}',
					authorid = '{$USER["id"]}',
					lastupdated = '".time()."',
					".($thumb ? "thumbnail = '{$thumb["url"]}'," : "")."
					".($thumb ? "thumbnailsize = '{$thumb["width"]}x{$thumb["height"]}'," : "")."
					auth_access = '{$auth_access}'
				WHERE ID = '{$id}'
				", __FILE__, __LINE__);

				slog("downloads: category '$id' was updated", "actions", 1);
			break;
			case "create":

				varImport("status", "categorylink", "title", "description", "auth_access");

				varRequire("title");

				// a thumbnail is required to create a category
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					$thumb = file_get("local_file", "remote_file", "temp");
					if ($thumb) {
						$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
					} else {
						trigger_error("Couldn't upload thumbnail!", E_USER_ERROR);
						abort();
					}
				}

				$db->query ("
				INSERT INTO ".db_table("download")."
					(
      					id,
						categorylink,
						title,
						description,
						status,
						thumbnail,
						thumbnailsize,
						authorid,
						creationtime,
						lastupdated,
						auth_access
					)
						VALUES
					(
						'".$db->free_id("download")."',
						'{$categorylink}',
						'{$title}',
						'{$description}',
						'{$status}',
						'".(isset($thumb["url"]) ? $thumb["url"] : "")."',
						'".(isset($thumb["url"]) ? $thumb["width"]."x".$thumb["height"] : "")."',
						'{$USER["id"]}',
						'".time()."',
						'".time()."',
						'{$auth_access}'
					)
				", __FILE__, __LINE__);

				slog("downloads: new sub category '$title' filed under category id = '$categorylink'", "actions", 2);
			break;
			case "edit_item":

				varImport("id", "downloadlink", "title", "description", "link_only",
				"downloadurl", "thumbnail", "allowcomments");

				varRequire("id", "title", "downloadlink");

				// checking if the user wants to change this item's download
				$media = Array();
				if ((!$link_only) && ($_POST["remote_media"] || $_FILES["local_media"]["size"])) {
					// getting file by specified url or submission
					$media = file_get("local_media", "remote_media", "data/downloads");
					if (!file_exists($media["abs_loc"]))
						abort("Coudln't upload/download file.");
				} elseif ($link_only && $_POST["remote_media"]) {
					// only linking
					$media["rel_loc"] = $_POST["remote_media"];
				}

				if (!$title)
					$title = beauty_basename($media["rel_loc"]);

				// this user has specified a thumbnail, it means that he wants to
				// delete the older one
				$thumb = Array();
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					$thumb = file_get("local_file", "remote_file", "data/gallery");
					if ($thumb)
						$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
				}

				// a new download or thumbnail was specified, the user wants to remove
				// older files.
				if ($media || $thumb) {
					$db->query("SELECT thumbnail, downloadurl FROM ".db_table("download_item")."
					WHERE id = '{$id}'", __FILE__, __LINE__);
					$row = $db->fetch_row();
					if ($media)
						@unlink(GEKKO_ROOT.$row["downloadurl"]);
					if ($thumb)
						@unlink(GEKKO_ROOT.$row["thumbnail"]);
				}

				$db->query("UPDATE ".db_table("download_item")." SET
					downloadlink = '{$downloadlink}',
					title = '{$title}',
					description = '{$description}',
					thumbnail = '".(isset($thumb["url"]) ? $thumb["url"] : $thumbnail)."',
					".($thumb ? "thumbnailsize = '{$thumb["width"]}x{$thumb["height"]}'," : "")."
					downloadurl = '".(isset($media["rel_loc"]) ? $media["rel_loc"] : $downloadurl)."',
					authorid = '{$USER["id"]}',
					lastupdated = '".time()."',
					allowcomments = '{$allowcomments}'
				WHERE ID = '{$id}'", __FILE__, __LINE__);

				slog("downloads: item id='$id' was updated", "actions", 1);
			break;
			case "add_item":

				unset($size);

				varImport("downloadlink", "title", "description", "link_only", "allowcomments", "filesize");

				varRequire("downloadlink");

				$media = Array();

				// media is required
				if ((!$link_only) && ($_POST["remote_media"] || $_FILES["local_media"]["size"])) {
					// saving media
					$media = file_get("local_media", "remote_media", "data/downloads");

					if (!file_exists($media["abs_loc"]))
						abort("Couldn't save file.");

				} elseif ($link_only && $_POST["remote_media"]) {
					// only linking
					$media["rel_loc"] = $_POST["remote_media"];
				} else {
					abort(_l("E_INSUFFICIENT_DATA"));
				}

				if (!$title)
					$title = beauty_basename($media["rel_loc"]);

				// when thumbnail is provided
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					$thumb = file_get("local_file", "remote_file", "data/gallery");
					if ($thumb) {
						if ($link_only) {
							// saving image size before resizing
							$media["size"] = imagesize($thumb["abs_loc"]);
						}
						$thumb = mkthumbnail($thumb["abs_loc"], conf::getKey("downloads", "thumbnail.longest_side"));
					}
				} else {
					$thumb = false;
				}

				// getting filesize
				if (!$filesize) {
					$filesize = r_filesize($media["rel_loc"]);
					if (!$filesize && isset($media["abs_loc"]))
						$filesize = r_filesize($media["abs_loc"]);
				}

				$db->query ("
				INSERT INTO ".db_table("download_item")."
					(
						id,
						downloadlink,
						title,
						description,
						thumbnail,
						thumbnailsize,
						downloadurl,
						authorid,
						creationtime,
						lastupdated,
						filesize,
						allowcomments
					)
						VALUES
					(
						'".$db->free_id("download_item")."',
						'{$downloadlink}',
						'{$title}',
						'{$description}',
						'".($thumb ? $thumb["url"] : "")."',
						'".($thumb ? $thumb["width"]."x".$thumb["height"] : "")."',
						'{$media["rel_loc"]}',
						'{$USER["id"]}',
						'".time()."',
						'".time()."',
						'{$filesize}',
						'{$allowcomments}'
					)
				", __FILE__, __LINE__);

				slog("downloads: added item to downloads category '$title'", "actions", 2);
			break;
		}

	}

	redirect($return);

	db_exit();
?>