<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.inc.php,v 1.1.1.1 2006/02/20 21:52:21 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"comments", "downloads", "format.lib.php"
	);

	Extract (
		URLGetArgs("null/action=alpha?id=int&page=page")
	);

	switch ($action) {
		case "get":
			if ($id) {

				// is this user allowed to download from this item's parent category?
				$cat_lock = "(downloadlink = '".implode("' OR downloadlink ='", downloads::allowedCategories())."')";

				$db->query("SELECT downloadurl, downloadlink
				FROM ".db_table("download_item")." WHERE id = '{$id}' AND $cat_lock",
				__FILE__, __LINE__);

				$row = $db->fetch_row();

				header("Location: ".rel_link($row["downloadurl"]));

				abort();
			}
		break;
		case "view":
			if ($id) {

				$tpl = new contentBlock();
				$tpl->insert("BLOCK_CONTENT", "downloads/item.tpl");

				$db->query("SELECT id, title, description, downloadurl, thumbnail,
				thumbnailsize, authorid, lastupdated, allowcomments, filesize
				FROM ".db_table("download_item")." WHERE id = '{$id}'",
				__FILE__, __LINE__);

				$row = $db->fetch_row();
				saneHTML($row, "description");
				format::style($row["description"], $row["authorid"]);

				if ($row["thumbnail"])
					list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnailsize"]);

				$row["downloadurl"] = rel_link($row["downloadurl"]);

				$tpl->set_arr($row);

				$tpl->set_arr (
					Array (
						"BLOCK_TITLE"	=> $row["title"],
						"BLOCK_ICON"	=> mkicon("downloads.png"),
						"PAGE"			=> $page
					)
				);

				$mcBuff = $tpl->make();

			}
		break;
		case "category":

			$tpl = new contentBlock();

			$tpl->insert("BLOCK_CONTENT", "downloads/category.tpl");

			$db->query("SELECT
			id, title, description, thumbnail, thumbnailsize, auth_access
			FROM ".db_table("download")." WHERE id = '{$id}'",
			__FILE__, __LINE__);

			$row = $db->fetch_row();

			if ($db->num_rows() && gauth($row["auth_access"])) {

				$pager = $db->pager (
					"SELECT id FROM ".db_table("download_item")."
					WHERE downloadlink = '{$row["id"]}'",
					"index.php/module=downloads/action=view/".title_encode($row["title"])."?id={$row["id"]}&page=%p",
					$page, conf::getkey("downloads", "items_per_page")
				);

				$db->query("SELECT id, title, description, thumbnail, thumbnailsize,
				lastupdated, authorid, allowcomments, downloadurl, filesize
				FROM ".db_table("download_item")."
				WHERE downloadlink = '{$row["id"]}' {$pager["sql"]}",
				__FILE__, __LINE__);

				$items = $db->num_rows();

				while ($row2 = $db->fetch_row()) {
					saneHTML($row2, "description");
					format::style($row2["description"], $row2["authorid"]);

					if ($row2["thumbnail"])
						list($row2["THUMBNAIL.WIDTH"], $row2["THUMBNAIL.HEIGHT"]) = explode("x", $row2["thumbnailsize"]);

					$row2["ACTIONS"] = new tplButtonBox();
					$row2["ACTIONS"]->add(mklink("index.php/module=downloads/action=get/".title_encode($row2["title"])."?id={$row2["id"]}", _l("L_DOWNLOAD"), "downloads.png"));
					$row2["ACTIONS"] = $row2["ACTIONS"]->make();

					$tpl->set_arr($row2, "ITEM");
					$tpl->savebuff("ITEM");
				}

				$tpl->set_arr ($row);

				$tpl->set_arr (
					Array (
						"BLOCK_TITLE"		=> _l("L_DOWNLOADS"),
						"BLOCK_ICON"		=> mkIcon("downloads.png", 16),
						"BLOCK_SUBTITLE"	=> $row["title"],
						"PAGER"				=> $pager["html"]
					)
				);

				$mcBuff = $tpl->make();
			} else {
				$mcBuff = accessDenied();
			}

		break;
		default: {

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "downloads/index.tpl");

			$allowed_categories = array();
			$tmp = Downloads::getCategories();
			while (list($i) = each($tmp))
				$allowed_categories[] = $i;
			$allowed_categories = "(id = '".implode("' OR id ='", $allowed_categories)."')";

			$pager = $db->pager (
				"SELECT id FROM ".db_table("download")."
				WHERE {$allowed_categories} ORDER BY title DESC",
				"index.php/module=downloads?page=%p", $page, conf::getKey("downloads", "items_per_page")
			);

			$db->query("SELECT
			id, title, description, categorylink, thumbnail, thumbnailsize, authorid, lastupdated
			FROM ".db_table("download")." WHERE {$allowed_categories} ORDER BY
			categorylink ASC, title ASC {$pager["sql"]}", __FILE__, __LINE__);

			if ($db->num_rows()) {
				$catnames = Array();
				while ($row = $db->fetch_row()) {
					if (!isset($catnames[$row["categorylink"]])) {
						if (count($catnames)) {
							$tpl->saveBuff("CATEGORY");
							$tpl->reset("CATEGORY.SUBCATEGORY");
						}
						$catnames[$row["categorylink"]] = true;
						$tpl->set_arr (
							Array (
								"ICON"		=> Categories::mkIcon($row["categorylink"]),
								"CATEGORY"	=> Categories::getCategory($row["categorylink"], true)
							),
						"CATEGORY");
					}

					if ($row["thumbnail"])
						list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnailsize"]);

					$tpl->set_arr($row, "CATEGORY.SUBCATEGORY");
					$tpl->savebuff("CATEGORY.SUBCATEGORY");
				}
				$tpl->saveBuff("CATEGORY");

				$tpl->set_arr (
					Array (
						"BLOCK_TITLE"	=> _l("L_DOWNLOADS"),
						"BLOCK_ICON"	=> mkIcon("downloads.png", 16),
						"PAGER"			=> $pager["html"]
					)
				);

				$mcBuff = $tpl->make();
			}
		}
	}

?>