<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.lib.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	define ("GEKKO_DOWNLOADS_DIR", GEKKO_ROOT."data/downloads/");

	LoadLib (
		"remote.lib.php", "file.lib.php", "categories"
	);

	mkworkdir(GEKKO_DOWNLOADS_DIR);

	Class Downloads {
		/**
		* getStatusList();
		* @returns: Human readable list of possible download items status
		*/
		function getStatusList() {
			$status = Array (
				_l("L_DISABLED"),
				_l("L_ENABLED")
			);
			return $status;
		}

		/**
		* countItems(category_id);
		* @returns: Items count for specified category
		*/
		function countItems($id = 0) {
			$q = $GLOBALS["db"]->query("SELECT id FROM ".db_table("download_item")."
			WHERE downloadlink = '{$id}'", __FILE__, __LINE__, true);
			return intval($GLOBALS["db"]->num_rows($q));
		}

		/**
		* getCategories();
		* @returns: A list of categories of download items
		*/
		function getCategories() {
			$q = $GLOBALS["db"]->query("SELECT id, title FROM ".db_table("download")."
			ORDER BY title ASC", __FILE__, __LINE__, true);
			$buff = Array();
			while ($row = $GLOBALS["db"]->fetch_row($q)) {
				$buff[$row["id"]] = $row["title"];
			}
			return $buff;
		}

		/**
		* deleteCategory(category_id);
		*
		*/
		function deleteCategory($id) {
			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT id FROM ".db_table("download_item")."
			WHERE downloadlink = '{$id}'", __FILE__, __LINE__, true);

			while ($row = $db->fetch_row($q)) {
				Downloads::deleteItem($row["id"]);
			}

			// deleting thumbnail
			$q = $db->query("SELECT
			thumbnail FROM ".db_table("download")."
			WHERE id = '{$id}'", __FILE__, __LINE__, true);
			$r = $db->fetch_row($q);

			@unlink(GEKKO_ROOT.$row["thumbnail"]);

			slog("downloads: deleted category '$id'", "actions", 1);

			return $db->query("DELETE FROM ".db_table("download")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}
		/**
		* deleteItem(item_id);
		*/
		function deleteItem($id) {
			$db =& $GLOBALS["db"];

			LoadLib ("comments");

			// deleting comments
			Comments::deleteItems("downloads", $id);

			$q = $db->query("SELECT thumbnail, downloadurl
			FROM ".db_table("download_item")." WHERE id = '{$id}'",
			__FILE__, __LINE__, true);
			$r = $db->fetch_row($q);

			// deleting media
			@unlink(GEKKO_ROOT.$r["thumbnail"]);
			@unlink(GEKKO_ROOT.$r["downloadurl"]);

			slog("downloads: deleted item '$id'", "actions", 1);

			return $GLOBALS["db"]->query ("DELETE FROM ".db_table("download_item")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}
		/**
		* setCategoryStatus(category_id, status);
		*/
		function setCategoryStatus($id, $status) {
			slog("downloads: status of '$id' changed to '$status'", "actions", 2);
			return $GLOBALS["db"]->query ("UPDATE ".db_table("download")." SET Status = '{$status}' WHERE ID='{$id}'", __FILE__, __LINE__, true);
		}

		function allowedCategories() {
			$db =& $GLOBALS["db"];

			$global_categories = Categories::fetchAllowed();

			$allowed = Array();
			$q = $db->query("SELECT id, auth_access, categorylink
			FROM ".db_table("download")." WHERE status = '1'",
			__FILE__, __LINE__, true);
			while ($row = $db->fetch_row($q)) {
				if (gauth($row["auth_access"]) && (isset($global_categories[$row["categorylink"]])))
					$allowed[$row["id"]] = $row["id"];
			}
			return $allowed;
		}
		/**
		* prepareRowForDisplay();
		* Does common processes for query rows
		*/
		function prepareRowForDisplay(&$row, $is_item = false) {
			$row["TITLE_ID"] = urlencode($row["title"]);

			if ($row["thumbnail"])
				list($row["THUMBNAIL.WIDTH"], $row["THUMBNAIL.HEIGHT"]) = explode("x", $row["thumbnailsize"]);

		}

		/**
		* allowComment(item_id);
		* @returns: does this item allow comments on it?
		*/
		function allowComment($thread) {
			$db =& $GLOBALS["db"];

			// checking item
			$q = $db->query("SELECT downloadlink
			FROM ".db_table("download_item")."
			WHERE id = '{$thread}' AND allowcomments = '1'", __FILE__, __LINE__, true);
			$row = $db->fetch_row($q);

			// checking access
			$q = $db->query("SELECT auth_access
			FROM ".db_table("download")."
			WHERE id = '{$row["downloadlink"]}' AND status = '1'");
			$row = $db->fetch_row($q);

			return $db->num_rows($q) ? gauth($row["auth_access"]) : false;
		}
	}
?>